import React from "react";
import { MdExpandLess, MdExpandMore } from "react-icons/md";
export function ChangingArrow({
  more,
  setMore,
}: {
  more: boolean;
  setMore: React.Dispatch<React.SetStateAction<boolean>>;
}) {
  return (
    <>
      {more ? (
        <MdExpandLess onClick={() => setMore(!more)} />
      ) : (
        <MdExpandMore onClick={() => setMore(!more)} />
      )}
    </>
  );
}
