import React from "react";
import { MdOutlineCancel, MdEdit, MdOutlineAdd } from "react-icons/md";
export function EditCancel({
  adder,
  edit,
  setEdit,
}: {
  adder: boolean;
  edit: boolean;
  setEdit: React.Dispatch<React.SetStateAction<boolean>>;
}) {
  return (
    <>
      {edit ? (
        <MdOutlineCancel onClick={() => setEdit(!edit)} />
      ) : adder ? (
        <MdOutlineAdd onClick={() => setEdit(!edit)} />
      ) : (
        <MdEdit onClick={() => setEdit(!edit)} />
      )}
    </>
  );
}
