package com.jakubu9333.grammarManager.config;

import com.jakubu9333.grammarManager.dao.XmlDataDao;
import org.basex.BaseXServer;
import org.basex.api.client.ClientSession;
import org.basex.core.cmd.Check;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpStatus;
import org.springframework.web.server.ResponseStatusException;

import java.io.IOException;

/**
 * @author Jakub Uhlarik
 */
@Configuration
public class XmlDataConfig{
        private XmlDataDao xmlDataDao;

        @Bean
        public XmlDataDao baseXMlDao()  {
            ClientSession session;
          

            try {
                BaseXServer server = new BaseXServer();
              session=  new ClientSession("localhost", 1984, "admin", "admin");

              session.execute(new Check("grammars"));
            } catch (IOException e) {
                System.out.println(e);
                throw new ResponseStatusException(HttpStatus.INTERNAL_SERVER_ERROR);
            }

            this.xmlDataDao=new XmlDataDao(session);

            return this.xmlDataDao;
        }

}
